# UnicodeSetIterator Class Reference

UnicodeSetIterator iterates over the contents of a UnicodeSet. More...

`#include <usetiter.h>`

Inheritance diagram for UnicodeSetIterator:

## Public Member Functions
| UnicodeSetIterator (const UnicodeSet &set)
| Create an iterator over the given set.
| UnicodeSetIterator ()
| Create an iterator over nothing.
virtual | ~UnicodeSetIterator ()
| Destructor.
UBool | isString () const
| Returns true if the current element is a string.
UChar32 | getCodepoint () const
| Returns the current code point, if `isString()` returned false.
UChar32 | getCodepointEnd () const
| Returns the end of the current code point range, if `isString()` returned false and `nextRange()` was called.
const UnicodeString & | getString ()
| Returns the current string, if `isString()` returned true.
UBool | next ()
| Advances the iteration position to the next element in the set, which can be either a single code point or a string.
UBool | nextRange ()
| Returns the next element in the set, either a code point range or a string.
void | reset (const UnicodeSet &set)
| Sets this iterator to visit the elements of the given set and resets it to the start of that set.
void | reset ()
| Resets this iterator to the start of the set.
virtual UClassID | getDynamicClassID () const
| ICU "poor man's RTTI", returns a UClassID for the actual class.
## Static Public Member Functions
static UClassID | getStaticClassID ()
| ICU "poor man's RTTI", returns a UClassID for this class.
## Protected Types
enum | { IS_STRING = -1 }
| Value of `codepoint` if the iterator points to a string. More...
## Protected Member Functions
| UnicodeSetIterator (const UnicodeSetIterator &)
| Copy constructor.
UnicodeSetIterator & | operator= (const UnicodeSetIterator &)
| Assignment operator.
virtual void | loadRange (int32_t range)
| Load range.
## Protected Attributes
UChar32 | codepoint
| Current code point, or the special value `IS_STRING`, if the iterator points to a string.
UChar32 | codepointEnd
| When iterating over ranges using `nextRange()`, `codepointEnd` contains the inclusive end of the iteration range, if `codepoint != IS_STRING`.
const UnicodeString * | string
| If `codepoint == IS_STRING`, then `string` points to the current string.
const UnicodeSet * | set
| The set.
int32_t | endRange
| End range.
int32_t | range
| Range.
int32_t | endElement
| End element.
int32_t | nextElement
| Next element.
int32_t | nextString
| Next string.
int32_t | stringCount
| String count.
UnicodeString * | cpString
| Points to the string to use when the caller asks for a string and the current iteration item is a code point, not a string.

## Detailed Description

UnicodeSetIterator iterates over the contents of a UnicodeSet.

It iterates over either code points or code point ranges. After all code points or ranges have been returned, it returns the multicharacter strings of the UnicodeSet, if any.

This class is not intended to be subclassed. Consider any fields or methods declared as "protected" to be private. The use of protected in this class is an artifact of history.

To iterate over code points and strings, use a loop like this:

     UnicodeSetIterator it(set);
     while (it.next()) {
         processItem(it.getString());
     }

Each item in the set is accessed as a string. Set elements consisting of single code points are returned as strings containing just the one code point.

To iterate over code point ranges, instead of individual code points, use a loop like this:

     UnicodeSetIterator it(set);
     while (it.nextRange()) {
       if (it.isString()) {
         processString(it.getString());
       } else {
         processCodepointRange(it.getCodepoint(), it.getCodepointEnd());
       }
     }

Author:
  M. Davis

Stable:
  ICU 2.4

Definition at line 61 of file usetiter.h.

## Member Enumeration Documentation

anonymous enum`[protected]`

Value of `codepoint` if the iterator points to a string.

If `codepoint == IS_STRING`, then examine `string` for the current iteration result.

Stable:
  ICU 2.4

Definition at line 71 of file usetiter.h.

## Constructor & Destructor Documentation

UnicodeSetIterator::UnicodeSetIterator | ( | const UnicodeSet & | set | ) |

Create an iterator over the given set.

The iterator is valid only so long as `set` is valid.

Parameters:

  | set | set to iterate over

Stable:
  ICU 2.4

UnicodeSetIterator::UnicodeSetIterator | ( |  | ) |

Create an iterator over nothing.

`next()` and `nextRange()` return false. This is a convenience constructor allowing the target to be set later.

Stable:
  ICU 2.4

virtual UnicodeSetIterator::~UnicodeSetIterator | ( |  | ) | `[virtual]`

Destructor.

Stable:
  ICU 2.4

UnicodeSetIterator::UnicodeSetIterator | ( | const UnicodeSetIterator & |  | ) | `[protected]`

Copy constructor.

Disallowed.

Stable:
  ICU 2.4

## Member Function Documentation

UChar32 UnicodeSetIterator::getCodepoint | ( |  | ) | const`[inline]`

Returns the current code point, if `isString()` returned false.

Otherwise returns an undefined result.

Stable:
  ICU 2.4

Definition at line 307 of file usetiter.h.

References codepoint.

UChar32 UnicodeSetIterator::getCodepointEnd | ( |  | ) | const`[inline]`

Returns the end of the current code point range, if `isString()` returned false and `nextRange()` was called.

Otherwise returns an undefined result.

Stable:
  ICU 2.4

Definition at line 311 of file usetiter.h.

References codepointEnd.

virtual UClassID UnicodeSetIterator::getDynamicClassID | ( |  | ) | const`[virtual]`

ICU "poor man's RTTI", returns a UClassID for the actual class.

Stable:
  ICU 2.4

Implements UObject.

static UClassID UnicodeSetIterator::getStaticClassID | ( |  | ) | `[static]`

ICU "poor man's RTTI", returns a UClassID for this class.

Stable:
  ICU 2.4

const UnicodeString& UnicodeSetIterator::getString | ( |  | ) |

Returns the current string, if `isString()` returned true.

If the current iteration item is a code point, a UnicodeString containing that single code point is returned.

Ownership of the returned string remains with the iterator. The string is guaranteed to remain valid only until the iterator is advanced to the next item, or until the iterator is deleted.

Stable:
  ICU 2.4

UBool UnicodeSetIterator::isString | ( |  | ) | const`[inline]`

Returns true if the current element is a string.

If so, the caller can retrieve it with `getString()`. If this method returns false, the current element is a code point or code point range, depending on whether `next()` or `nextRange()` was called. Elements of types string and codepoint can both be retrieved with the function `getString()`. Elements of type codepoint can also be retrieved with `getCodepoint()`. For ranges, `getCodepoint()` returns the starting codepoint of the range, and `getCodepointEnd()` returns the end of the range.

Stable:
  ICU 2.4

Definition at line 303 of file usetiter.h.

References codepoint.

virtual void UnicodeSetIterator::loadRange | ( | int32_t | range | ) | `[protected, virtual]`

Load range.

Stable:
  ICU 2.4

UBool UnicodeSetIterator::next | ( |  | ) |

Advances the iteration position to the next element in the set, which can be either a single code point or a string.

If there are no more elements in the set, return false.

If `isString() == TRUE`, the value is a string, otherwise the value is a single code point. Elements of either type can be retrieved with the function `getString()`, while elements of consisting of a single code point can be retrieved with `getCodepoint()`

The order of iteration is all code points in sorted order, followed by all strings sorted order. Do not mix calls to `next()` and `nextRange()` without calling `reset()` between them. The results of doing so are undefined.

Returns:
  true if there was another element in the set.

Stable:
  ICU 2.4

UBool UnicodeSetIterator::nextRange | ( |  | ) |

Returns the next element in the set, either a code point range or a string.

If there are no more elements in the set, return false. If `isString() == TRUE`, the value is a string and can be accessed with `getString()`. Otherwise the value is a range of one or more code points from `getCodepoint()` to `getCodepointeEnd()` inclusive.

The order of iteration is all code points ranges in sorted order, followed by all strings sorted order. Ranges are disjoint and non-contiguous. The value returned from `getString()` is undefined unless `isString() == TRUE`. Do not mix calls to `next()` and `nextRange()` without calling `reset()` between them. The results of doing so are undefined.

Returns:
  true if there was another element in the set.

Stable:
  ICU 2.4

UnicodeSetIterator& UnicodeSetIterator::operator= | ( | const UnicodeSetIterator & |  | ) | `[protected]`

Assignment operator.

Disallowed.

Stable:
  ICU 2.4

void UnicodeSetIterator::reset | ( |  | ) |

Resets this iterator to the start of the set.

Stable:
  ICU 2.4

void UnicodeSetIterator::reset | ( | const UnicodeSet & | set | ) |

Sets this iterator to visit the elements of the given set and resets it to the start of that set.

The iterator is valid only so long as `set` is valid.

Parameters:

  | set | the set to iterate over.

Stable:
  ICU 2.4

## Field Documentation

UChar32 UnicodeSetIterator::codepoint`[protected]`

Current code point, or the special value `IS_STRING`, if the iterator points to a string.

Stable:
  ICU 2.4

Definition at line 78 of file usetiter.h.

Referenced by getCodepoint(), and isString().

UChar32 UnicodeSetIterator::codepointEnd`[protected]`

When iterating over ranges using `nextRange()`, `codepointEnd` contains the inclusive end of the iteration range, if `codepoint != IS_STRING`.

If iterating over code points using `next()`, or if `codepoint == IS_STRING`, then the value of `codepointEnd` is undefined.

Stable:
  ICU 2.4

Definition at line 89 of file usetiter.h.

Referenced by getCodepointEnd().

UnicodeString* UnicodeSetIterator::cpString`[protected]`

Points to the string to use when the caller asks for a string and the current iteration item is a code point, not a string.

Internal:
  Do not use. This API is for internal use only.

Definition at line 284 of file usetiter.h.

int32_t UnicodeSetIterator::endElement`[protected]`

End element.

Stable:
  ICU 2.4

Definition at line 264 of file usetiter.h.

int32_t UnicodeSetIterator::endRange`[protected]`

End range.

Stable:
  ICU 2.4

Definition at line 256 of file usetiter.h.

int32_t UnicodeSetIterator::nextElement`[protected]`

Next element.

Stable:
  ICU 2.4

Definition at line 268 of file usetiter.h.

int32_t UnicodeSetIterator::nextString`[protected]`

Next string.

Stable:
  ICU 2.4

Definition at line 273 of file usetiter.h.

int32_t UnicodeSetIterator::range`[protected]`

Range.

Stable:
  ICU 2.4

Definition at line 260 of file usetiter.h.

const UnicodeSet* UnicodeSetIterator::set`[protected]`

The set.

Stable:
  ICU 2.4

Definition at line 252 of file usetiter.h.

const UnicodeString* UnicodeSetIterator::string`[protected]`

If `codepoint == IS_STRING`, then `string` points to the current string.

If `codepoint != IS_STRING`, the value of `string` is undefined.

Stable:
  ICU 2.4

Definition at line 97 of file usetiter.h.

int32_t UnicodeSetIterator::stringCount`[protected]`

String count.

Stable:
  ICU 2.4

Definition at line 277 of file usetiter.h.

The documentation for this class was generated from the following file:

- usetiter.h